/[sysadmin-cookbook]/recepies/lxc/lxc-watchdog.sh
This is repository of my old source code which isn't updated any more. Go to git.rot13.org for current projects!
ViewVC logotype

Contents of /recepies/lxc/lxc-watchdog.sh

Parent Directory Parent Directory | Revision Log Revision Log


Revision 195 - (show annotations)
Wed Mar 24 19:03:16 2010 UTC (10 years, 4 months ago) by dpavlin
File MIME type: application/x-sh
File size: 4773 byte(s)
lxc-ls displays random files in /var/lib/lxc/ and duplicates so don't use it

1 #! /bin/sh
2 ### BEGIN INIT INFO
3 # Provides: lxc-watchdog
4 # Required-Start: $remote_fs $named $network $time
5 # Required-Stop: $remote_fs $named $network
6 # Required-Start:
7 # Required-Stop:
8 # Default-Start: 2 3 4 5
9 # Default-Stop: 0 1 6
10 # Short-Description: Manage Linux Containers startup/shutdown
11 # Description: Uses clever inotify hack to monitor container's
12 # halt/reboot events watching /var/run/utmp
13 ### END INIT INFO
14
15 # Author: Dobrica Pavlinusic <dpavlin@rot13.org>
16 #
17 # based on Tony Risinger post to lxc-users mailing list
18 # http://www.mail-archive.com/lxc-users@lists.sourceforge.net/msg00074.html
19 #
20 # Install with:
21 # ln -sf /srv/sysadmin-cookbook/recepies/lxc/lxc-watchdog.sh /etc/init.d/lxc-watchdog
22 # update-rc.d lxc-watchdog defaults
23
24
25 which inotifywait >/dev/null || apt-get install inotify-tools
26
27
28 lxc_exists() {
29 name=$1
30
31 if [ ! -e /var/lib/lxc/$name/config ] ; then
32 echo "Usage: $0 name"
33 lxc_status
34 exit 1
35 fi
36 }
37
38
39 lxc_rootfs() {
40 grep '^ *lxc\.rootfs *=' "/var/lib/lxc/$1/config" | cut -d= -f2 | sed 's/^ *//'
41 }
42
43
44 lxc_status() {
45 find /var/lib/lxc/ -name "config" | cut -d/ -f5 | sort -u | xargs -i lxc-info -n {} | sed "s/'//g" | while read name is status ; do
46 boot=" "
47 test -s /var/lib/lxc/$name/on_boot && boot="boot"
48 echo "$name $status $boot $(lxc_rootfs $name)"
49 done
50 }
51
52
53 cleanup_init_scripts() {
54 rootfs=$(lxc_rootfs $1)
55
56 ls \
57 $rootfs/etc/rc?.d/*umountfs \
58 $rootfs/etc/rc?.d/*umountroot \
59 $rootfs/etc/rc?.d/*hwclock* \
60 2>/dev/null | xargs -i rm -v {}
61 }
62
63
64 setup_inittab() {
65 rootfs=$(lxc_rootfs $1)
66 remove=$2
67 add=$3
68
69 # let container respond to kill -SIGPWR
70 inittab=$rootfs/etc/inittab
71 if ! grep "$add" ${inittab} >/dev/null ; then
72 grep -v "$remove" ${inittab} > ${inittab}.new
73 echo $add >> ${inittab}.new
74 mv ${inittab}.new ${inittab}
75 echo "$inittab modified with $add"
76 fi
77 }
78
79
80 lxc_log() {
81 echo `date +%Y-%m-%dT%H:%M:%S` $*
82 }
83
84
85 lxc_kill() {
86 name=$1
87 sig=$2
88
89 init_pid=`lxc-ps -C init -o pid | grep "^$name" | cut -d" " -f2-`
90 if [ -z "$init_pid" ] ; then
91 lxc-info -n $name
92 exit 1
93 fi
94 lxc_log "$name kill $sig $init_pid"
95 /bin/kill $sig $init_pid
96 }
97
98 lxc_stop() {
99 lxc_log "$name stop"
100 lxc_kill $name -SIGPWR
101 lxc-wait -n $name -s STOPPED
102 lxc_log "$name stoped"
103 # rm -f /var/lib/lxc/${name}/on_boot
104 }
105
106
107 lxc_start() {
108 name=$1
109
110 if ! lxc-info -n $name | grep RUNNING ; then
111 lxc_log "$name start"
112 lxc-start -n $name -o /tmp/${name}.log -d
113 lxc-wait -n $name -s RUNNING
114 lxc-info -n $name
115 test -f /var/lib/lxc/${name}/on_boot || echo $name > /var/lib/lxc/${name}/on_boot
116 fi
117 }
118
119 lxc_watchdog() {
120 name=$1
121 rootfs=$(lxc_rootfs $1)
122
123 while true; do
124 vps_utmp=${rootfs}/var/run/utmp
125 tasks=`wc -l < /cgroup/${name}/tasks`
126 test -z "$tasks" && exit 1
127 if [ "$tasks" -eq 1 ]; then
128
129 runlevel="$(runlevel ${vps_utmp})"
130 lxc_log "$name runlevel $runlevel"
131
132 case $runlevel in
133 N*)
134 # nothing for new boot state
135 ;;
136 ??0)
137 lxc_log "$name halt"
138 lxc-stop -n "${name}"
139 lxc-wait -n ${name} -s STOPPED
140 break
141 ;;
142 ??6)
143 lxc_log "$name reboot";
144 lxc-stop -n ${name}
145 lxc-wait -n ${name} -s STOPPED
146 lxc-start -d -n ${name} -o /tmp/${name}.log
147 ;;
148 *)
149 # make sure vps is still running
150 state="$(lxc-info -n "${name}" | sed -e 's/.* is //')"
151 [ "$state" = "RUNNING" ] || break
152 ;;
153 esac
154 else
155 lxc_log "$name $tasks tasks"
156 fi
157
158 # time of 5 minutes on it JUST IN CASE...
159 inotifywait -qqt 300 ${vps_utmp}
160 done
161
162 lxc_log "$name watchdog exited"
163
164 }
165
166
167 usage() {
168 echo "Usage: $0 {start|stop|restart|status|boot|disable} [name name ... ]" >&2
169 exit 3
170 }
171
172 command_on_lxc() {
173 command=$1
174 shift
175
176 echo "# $command $1"
177
178 case "$command" in
179
180 start)
181 lxc_exists $1
182 cleanup_init_scripts $1
183 setup_inittab $1 ":respawn:/sbin/getty.*tty1" "c1:12345:respawn:/sbin/getty 38400 tty1 linux"
184 setup_inittab $1 "::power" "p0::powerfail:/sbin/init 0"
185 setup_inittab $1 "::ctrlaltdel" "p6::ctrlaltdel:/sbin/init 6"
186 lxc_start $1
187 # give container 5 seconds to start more than one process
188 ( sleep 5 ; nohup $0 watchdog $1 >> /tmp/$1.log 2>/dev/null ) &
189 ;;
190 stop|halt)
191 lxc_exists $1
192 lxc_stop $1
193 ;;
194 reload|force-reload|restart|reboot)
195 lxc_kill $1 -SIGINT
196 ;;
197 watchdog)
198 lxc_watchdog $1
199 ;;
200 boot)
201 echo $1 > /var/lib/lxc/$1/on_boot
202 ;;
203 disable)
204 echo -n > /var/lib/lxc/$1/on_boot
205 ;;
206 *)
207 usage
208 ;;
209
210 esac
211
212 }
213
214 command=$1
215 test -z "$command" && usage
216 test "$command" = "status" && lxc_status && exit
217 shift
218
219 if [ -z "$1" ] ; then
220 ls /var/lib/lxc/*/on_boot | while read path ; do
221 name=`echo $path | cut -d/ -f5`
222 if [ "$command" != "start" -o "$command" = "start" -a -s $path ] ; then
223 command_on_lxc $command $name
224 else
225 echo "# skip $command $name"
226 fi
227 done
228 else
229 while [ ! -z "$1" ] ; do
230 command_on_lxc $command $1
231 shift
232 done
233 fi
234

Properties

Name Value
svn:executable *

  ViewVC Help
Powered by ViewVC 1.1.26